﻿using System;
using System.Drawing;
using System.Windows.Forms;

using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 자식 폼 1
    /// </summary>
    public partial class ChildForm1 : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 시작 포인트
        /// </summary>
        private Point startPoint;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ChildForm1()

        /// <summary>
        /// 생성자
        /// </summary>
        public ChildForm1()
        {
            InitializeComponent();

            this.listBoxControl.MouseDown += listBoxControl_MouseDown;
            this.listBoxControl.MouseMove += listBoxControl_MouseMove;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 리스트 박스 컨트롤 마우스 DOWN 처리하기 - listBoxControl_MouseDown(sender, e)

        /// <summary>
        /// 리스트 박스 컨트롤 마우스 DOWN 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void listBoxControl_MouseDown(object sender, MouseEventArgs e)
        {
            ListBoxControl listBoxControl = sender as ListBoxControl;

            this.startPoint = new Point(e.X, e.Y);

            int selectedIndex = listBoxControl.IndexFromPoint(startPoint);

            if(selectedIndex == -1)
            {
                this.startPoint = Point.Empty;
            }
        }

        #endregion
        #region 리스트 박스 컨트롤 마우스 이동시 처리하기 - listBoxControl_MouseMove(sender, e)

        /// <summary>
        /// 리스트 박스 컨트롤 마우스 이동시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void listBoxControl_MouseMove(object sender, MouseEventArgs e)
        {
            ListBoxControl listBoxControl = sender as ListBoxControl;

            if(e.Button == MouseButtons.Left)
            {
                if
                (
                    (startPoint != Point.Empty) &&
                    (
                        (Math.Abs(e.X - startPoint.X) > SystemInformation.DragSize.Width ) ||
                        (Math.Abs(e.Y - startPoint.Y) > SystemInformation.DragSize.Height)
                    )
                )
                {
                    listBoxControl.DoDragDrop(listBoxControl.SelectedItem, DragDropEffects.Copy);
                }
            }
        }

        #endregion
    }
}