﻿using System.Windows.Forms;

using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 자식 폼 2
    /// </summary>
    public partial class ChildForm2 : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ChildForm2()

        /// <summary>
        /// 생성자
        /// </summary>
        public ChildForm2()
        {
            InitializeComponent();

            this.listBoxControl.DragDrop += listBoxControl_DragDrop;
            this.listBoxControl.DragOver += listBoxControl_DragOver;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 리스트 박스 컨트롤 드래그 OVER 처리하기 - listBoxControl_DragOver(sender, e)

        /// <summary>
        /// 리스트 박스 컨트롤 드래그 OVER 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void listBoxControl_DragOver(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Copy;
        }

        #endregion
        #region 리스트 박스 컨트롤 드래그 DROP 처리하기 - listBoxControl_DragDrop(sender, e)

        /// <summary>
        /// 리스트 박스 컨트롤 드래그 DROP 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void listBoxControl_DragDrop(object sender, DragEventArgs e)
        {
            if(e.Data.GetDataPresent(typeof(string)))
            {
                string text = (string)e.Data.GetData(typeof(string));

                this.listBoxControl.Items.Add(text);
            }
        }

        #endregion
    }
}