using System.Drawing;
using System.Windows.Forms;

using DevExpress.Utils.Mdi;
using DevExpress.XtraTab;
using DevExpress.XtraTab.ViewInfo;
using DevExpress.XtraTabbedMdi;

namespace TestProject
{
    /// <summary>
    /// 巡 
    /// </summary>
    public class DragHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// XTRA  MDI 
        /// </summary>
        private XtraTabbedMdiManager manager;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 巡׽     - SelectNewPageOnDrag

        /// <summary>
        /// 巡׽    
        /// </summary>
        public bool SelectNewPageOnDrag
        {
            set
            {
                MDIClient.DragOver -= MDIClient_DragOver;

                if(value)
                {
                    MDIClient.DragOver += MDIClient_DragOver;
                }
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region MDI Ŭ̾Ʈ - MDIClient

        /// <summary>
        /// MDI Ŭ̾Ʈ
        /// </summary>
        private MdiClient MDIClient
        {
            get
            {
                return MdiClientSubclasser.GetMdiClient(this.manager.MdiParent);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - DragHelper(manager)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="manager">XTRA  MDI </param>
        public DragHelper(XtraTabbedMdiManager manager)
        {
            this.manager = manager;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region MDI Ŭ̾Ʈ 巡 OVER óϱ - MDIClient_DragOver(sender, e)

        /// <summary>
        /// MDI Ŭ̾Ʈ 巡 OVER óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        protected void MDIClient_DragOver(object sender, DragEventArgs e)
        {
            IXtraTab xtraTab = this.manager as IXtraTab;

            Point mousePoint = xtraTab.ScreenPointToControl(new Point(e.X, e.Y));

            BaseTabHitInfo hitInfo = this.manager.CalcHitInfo(mousePoint);

            if(hitInfo.HitTest == XtraTabHitTest.PageHeader)
            {
                this.manager.SelectedPage = (XtraMdiTabPage)hitInfo.Page;
            }
        }

        #endregion
    }
}